//
// Copyright (c) Microsoft. All rights reserved.
// See https://aka.ms/azai/vision/license for the full license information.
//

#pragma once
#include "azac_api_cxx_details_property_collection.hpp"
#include "vision_api_cxx_common.hpp"
#include "vision_api_cxx_frame_format_property.hpp"

namespace Azure {
namespace AI {
namespace Vision {
namespace Input {
namespace Frames {

/// <summary>
/// Represents the collection of properties for a FrameFormat instances
/// </summary>
class FrameFormatProperties : private AI::Core::_detail::PropertyCollectionBase<Frames::FrameFormatProperty>
{
private:
    template<typename Target>
    using ProtectedAccess = Azure::AI::Core::_detail::ProtectedAccess<Target>;
    using PropertyCollection = AI::Core::_detail::PropertyCollectionBase<Frames::FrameFormatProperty>;

public:
    using PropertyCollection::Set;
    using PropertyCollection::Get;

private:

    friend class AI::Core::_detail::ProtectedAccess<Frames::FrameFormatProperties>;
    friend class Azure::AI::Core::_detail::PropertyCollection<Azure::AI::Vision::Input::Frames::FrameFormatProperty, Azure::AI::Vision::Input::Frames::FrameFormatProperties>;

    FrameFormatProperties(AZAC_HANDLE handle) : PropertyCollection(handle) {}
    explicit operator AZAC_HANDLE() { return ProtectedAccess<PropertyCollection>::HandleFromPtr(this); }
};

} } } } } // Azure::AI::Vision::Input::Frames
