//
// Copyright (c) Microsoft. All rights reserved.
// See https://aka.ms/azai/vision/license for the full license information.
//

#pragma once
#include "azac_api_cxx_details_property_collection.hpp"
#include "vision_api_cxx_common.hpp"
#include "vision_api_cxx_session_result_property.hpp"

namespace Azure {
namespace AI {
namespace Vision {
namespace Core {
namespace Session {

/// <summary>
/// Represents the collection of properties on a given SessionResultResult
/// </summary>
class SessionResultProperties : private AI::Core::_detail::PropertyCollectionBase<SessionResultProperty>
{
private:
    template<typename Target>
    using ProtectedAccess = Azure::AI::Core::_detail::ProtectedAccess<Target>;
    using PropertyCollection = AI::Core::_detail::PropertyCollectionBase<SessionResultProperty>;

public:
    using PropertyCollection::Set;
    using PropertyCollection::Get;

private:

    friend class AI::Core::_detail::ProtectedAccess<SessionResultProperties>;
    friend class Azure::AI::Core::_detail::PropertyCollection<Azure::AI::Vision::Core::Session::SessionResultProperty, Azure::AI::Vision::Core::Session::SessionResultProperties>;
    friend class Azure::AI::Core::_detail::PropertyCollection<int, Azure::AI::Vision::Core::Session::SessionResultProperties>;

    SessionResultProperties(AZAC_HANDLE handle) : PropertyCollection(handle) {}
    explicit operator AZAC_HANDLE() { return ProtectedAccess<PropertyCollection>::HandleFromPtr(this); }
};

} } } } } // Azure::AI::Vision::Core::Session
