//
// Copyright (c) Microsoft. All rights reserved.
// See https://aka.ms/azai/vision/license for the full license information.
//

#pragma once
#include "azac_api_cxx_details_property_collection.hpp"
#include "vision_api_cxx_common.hpp"
#include "vision_api_cxx_source_property.hpp"

namespace Azure {
namespace AI {
namespace Vision {
namespace Input {

/// <summary>
/// Represents the collection of properties on a given VisionSource instance
/// </summary>
class VisionSourceProperties : private AI::Core::_detail::PropertyCollectionBase<Input::VisionSourceProperty>
{
private:
    template<typename Target>
    using ProtectedAccess = Azure::AI::Core::_detail::ProtectedAccess<Target>;
    using PropertyCollection = AI::Core::_detail::PropertyCollectionBase<Input::VisionSourceProperty>;

public:
    using PropertyCollection::Set;
    using PropertyCollection::Get;

private:

    friend class AI::Core::_detail::ProtectedAccess<Input::VisionSourceProperties>;
    friend class Azure::AI::Core::_detail::PropertyCollection<Azure::AI::Vision::Input::VisionSourceProperty, Azure::AI::Vision::Input::VisionSourceProperties>;

    VisionSourceProperties(AZAC_HANDLE handle) : PropertyCollection(handle) {}
    explicit operator AZAC_HANDLE() { return ProtectedAccess<PropertyCollection>::HandleFromPtr(this); }
};

} } } } // Azure::AI::Vision::Input
